/******************************************************************************
 * sample.h
 * SASS Compiler for CoreTone, sample descriptor parsing and pack generation.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 Osman Celimli
 * For conditions of distribution and use, see copyright notice in ctcc.c
 ******************************************************************************/
#ifndef CTCC_SAMPLE
#define CTCC_SAMPLE

/******************************************************************************
 * Operating Parameters
 ******************************************************************************/
#define SAMPLE_PARSER_LINEBUF_LEN	2048
#define SAMPLE_PARSER_FREQ_MIN		1.0
#define SAMPLE_PARSER_FREQ_MAX		65535.9999999999999999
#define SAMPLE_PARSER_LENGTH_MIN	0
#define SAMPLE_PARSER_LENGTH_MAX	CORETONE_SAMPLES_MAXLENGTH
#define SAMPLE_PARSER_END_TAG		(CORETONE_SAMPLES_MAXLENGTH + 1)

#define SAMPLE_DTABLE_BASE_LEN		64

/******************************************************************************
 * Sample Descriptors
 ******************************************************************************/
typedef struct Sample_s {
	char *pszName,*pszFile;

	uint32_t uiStart,uiEnd;
	uint32_t uiOffset,uiLength;
	uint8_t *pData;

	uint32_t uiFileNum;
	int32_t iSkipLoad;

	double dSf,dBf;
} Sample_t;

/* Sample Descriptor Table
 *------------------------------------*/
extern Sample_t *pSamples;
extern uint32_t uiSamples;

/******************************************************************************
 * Function Defines
 ******************************************************************************/
int32_t smp_parse(FILE *pDesc, char *pszFileName);
int32_t smp_make(FILE *pDest, char *pszFileName);
void smp_close(void);

int32_t smp_get(char *pszName, uint32_t *puiNum, Sample_t **ppSample);

#endif
