/******************************************************************************
 * toneman.hpp
 * Secondary wrapper around WinTone + CoreTone to manage resources.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 Osman Celimli
 * For conditions of distribution and use, see copyright notice in playtone.cpp
 ******************************************************************************/
#ifndef TONEMAN
#define TONEMAN

class ToneMan {
	public:
		ToneMan(HWND hParent);
		~ToneMan(void);


		HRESULT StartDriver(void);
		HRESULT StopDriver(void);

		HRESULT StartLog(LPSTR pszFile);
		HRESULT StopLog(void);

		HRESULT LoadFile(LPSTR pszFile, BYTE **ppDest);
		HRESULT LoadSamples(LPSTR pszFile);
		HRESULT LoadInstruments(LPSTR pszFile);
		HRESULT LoadMusic(LPSTR pszFile);
		HRESULT LoadSfx(LPSTR pszFile);


		void Pause(void);
		void Resume(void);
		void StopAll(void);

		void PlayMusic(void);
		void StopMusic(void);
		void AttenMusic(BYTE cVol);
		void PlaySfx(INT iPriority, INT iVol_Left, INT iVol_Right);
		void StopSfx(void);


		HWND mhParent;
		BOOL mbDriverRunning,mbLogging;

		BOOL mbSamplesReady,mbInstrumentsReady;
		BYTE *mpSamples,*mpInstruments;

		BOOL mbMusicReady;
		BYTE *mpMusic;

		BOOL mbSfxReady;
		BYTE *mpSfx;
		INT miLastPriority;
};

#endif